package Package_ScriptBPC
{
	function SERVERCMDPlantBrick(%cl)
	{
		if(!isObject(%br = %cl.player.tempbrick) || !$Pref::Server::BPCst::CostEnabled || (%cl.isSuperAdmin && !$Pref::Server::BPCst::EnabCostSA))
			return Parent::servercmdPlantBrick(%cl);
		if(%br.PTGgenerated || %br.SGen2D_Generated || %br.SGen3D_Generated)
			return Parent::servercmdPlantBrick(%cl);
		
		%score = %cl.score;
		%brCost = SBPCost_GetBrValue(%br,"Cost");
			
		if(%score >= %brCost)
			%buildPass = true;
		else
		{
			if(%brCost != 1) %plural = "s";
			commandToClient(%cl,'centerPrint',"You don't have enough points to plant this brick! <br>\c3" @ %brCost @ " \c0point" @ %plural @ " are required, you have \c3" @ %score,3);

			return;
		}
		
		%plantedBr = Parent::servercmdPlantBrick(%cl); //prevent deducting cost if brick fails ModTer restriction script
		
		if(isObject(%plantedBr))
		{
			if(%buildPass)
			{
				%cl.score -= %brCost;
				
				//Display change in score after planting brick
				switch($Pref::Server::BPCst::NotifyType)
				{
					case 0:
						commandToClient(%cl,'bottomPrint',"\c2Total Points: " @ %cl.score @ " \c6(-" @ %brCost @ ")",2);
					case 1:
						commandToClient(%cl,'centerPrint',"\c2Total Points: " @ %cl.score @ " \c6(-" @ %brCost @ ")",2);
					case 2:
						messageClient(%cl,"","\c2Total Points: " @ %cl.score @ " \c6(-" @ %brCost @ ")");
				}
			}
			
			return %plantedBr;
		}

		return Parent::servercmdPlantBrick(%cl);
	}
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	function fxDTSBrick::onToolBreak(%this,%cl)
	{
		%parent = parent::onToolBreak(%this,%cl); //function is invoked prior to .killBrick, so we can access brick data after calling parent
		%br = %this;
		
		if(!$Pref::Server::BPCst::RebateEnabled || (%cl.isSuperAdmin && !$Pref::Server::BPCst::EnabRebateSA))
			return %parent;
		if(!isObject(%br) || %br.PTGgenerated || %br.SGen2D_Generated || %br.SGen3D_Generated)
			return %parent;
		
		//Add Points Back To Player
		%brRbt = SBPCost_GetBrValue(%br,"Rebate");
		%score = %cl.score += %brRbt;
		
		//Display change in score after destroying brick
		switch($Pref::Server::BPCst::NotifyType)
		{
			case 0:
				commandToClient(%cl,'bottomPrint',"\c2Total Points: " @ %score @ " \c6(+" @ %brRbt @ ")",2);
			case 1:
				commandToClient(%cl,'centerPrint',"\c2Total Points: " @ %score @ " \c6(+" @ %brRbt @ ")",2);
			case 2:
				messageClient(%cl,"","\c2Total Points: " @ %score @ " \c6(+" @ %brRbt @ ")");
		}

		return %parent;
	}
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	function SERVERCMDUndoBrick(%cl)
	{
		if(!$Pref::Server::BPCst::RebateEnabled || (%cl.isSuperAdmin && !$Pref::Server::BPCst::EnabRebateSA))
			return parent::SERVERCMDUndoBrick(%cl);

		%queue = %cl.undoStack;
		%brPos = %queue.head;
		
		if(%brPos < 1)
			return parent::SERVERCMDUndoBrick(%cl);
		
		%queueData = %queue.val[%brPos - 1];
		%br = getField(%queueData,0);
		%brAct = getField(%queueData,1);
		
		if(!isObject(%br) || !%br.isPlanted || %brAct !$= "PLANT" || getBrickGroupFromObject(%br).getName() $= "BrickGroup_888888")
			return parent::SERVERCMDUndoBrick(%cl);

		%brRbt = SBPCost_GetBrValue(%br,"Rebate");
		%score = %cl.score += %brRbt;
		
		//Display change in score after destroying brick
		switch($Pref::Server::BPCst::NotifyType)
		{
			case 0:
				commandToClient(%cl,'bottomPrint',"\c2Total Points: " @ %score @ " \c6(+" @ %brRbt @ ")",2);
			case 1:
				commandToClient(%cl,'centerPrint',"\c2Total Points: " @ %score @ " \c6(+" @ %brRbt @ ")",2);
			case 2:
				messageClient(%cl,"","\c2Total Points: " @ %score @ " \c6(+" @ %brRbt @ ")");
		}

		return parent::SERVERCMDUndoBrick(%cl); //allow brick to be destroyed
	}
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	function onServerDestroyed()
	{
		deleteVariables("$SBPCost_ValArr*");
		
		return Parent::onServerDestroyed();
	}
};
activatePackage(Package_ScriptBPC);